#!/usr/bin/env python

from math import ceil
import sys

def nextstep(step):
    return int(ceil(step / 2.0))

def binsearch(slist, val):
    imax = len(slist)
    #i = nextstep(imax)     
    i = int(ceil(imax / 2.0))
    step = imax
    found = None
    while found == None:
        #print i
        if i>=0 and i<imax:   
            test = slist[i]
            if test == val:
                found = True
            elif step == 1 and test != val:
                found = False
            else:
                step = int(ceil(step / 2.0))
                i += (step if test < val else -step)
        else:
            step = int(ceil(step / 2.0))
            i += (step if i<0 else -step)
    return found


def main(upper):
    mlist = range(3, upper*297+3, 297)
    print len(mlist),
    for i in range(upper*297+3):
        res = (binsearch(mlist, i) == (i in mlist))
        if not res:
            print "...\tFail"
            print i, binsearch(mlist, i)
            sys.exit(1)
    print "...\tPass"
        

if __name__ == "__main__":
    for i in range(1, 415):
        main(i)
    sys.exit(0)